Page MenuHomePhabricator

Assign due date to task and have tasks with due dates displayed on a calendar
Open, LowPublic

Tokens
"Like" token, awarded by VMasrour-WMF."Like" token, awarded by Delphine_wmf."Like" token, awarded by Ziad."Like" token, awarded by MichaelAquilina."Like" token, awarded by Jaredzimmerman-WMF."Like" token, awarded by Ironholds.
Assigned To
None
Authored By

Description

Report upstream: https://secure.phabricator.com/T7930

This is a useful feature for teams that don't align exactly with sprint deadlines like Analytics, Design, and Research. As well as longer term planning. Due data granularity sometimes needs to be greater than sprints.

Related Objects

Event Timeline

Jaredzimmerman-WMF updated the task description. (Show Details)
Jaredzimmerman-WMF raised the priority of this task from to Needs Triage.
Jaredzimmerman-WMF changed Security from none to None.
Qgil updated the task description. (Show Details)Nov 26 2014, 10:47 PM
Qgil triaged this task as Lowest priority.
Qgil moved this task from Backlog to Wikimedia requests on the Phabricator (Upstream) board.

Please try to only file one request per task. Thank you. :)

Qgil raised the priority of this task from Lowest to Low.Dec 17 2014, 10:52 AM

The problem of adding a plain custom field is that all tasks would get such field, when its use would be marginal.

I will advocate again for tags like #March-2015 to be used in tasks that have mid-term milestones that cannot be tracked with sprints. It's a simpler solution, but I think it addresses big part of the problem.

Also, I wonder whether we have many tasks that have a hard dependency on a date, as opposed to dependencies on blocking tasks, or on projects that have certain dates assigned. Having real examples of tasks needing this feature. This task has been marked as a blocker of T832: Migration of the Design team to Phabricator, so I guess this is where we need to look first.

Research & Data also uses due dates.

He7d3r added a subscriber: He7d3r.Dec 17 2014, 10:49 PM
He7d3r added a subscriber: raylton.sousa.
Qgil added a comment.Dec 18 2014, 2:15 PM

Is there a calendar in Trello to see these tasks with due dates? I have been clicking to several cards in your boards and I just found one (which was due for a month). :)

Do you use dates in addition to sprints or instead of sprints?


The calendar itself is a "powerup" in trello, e.g. an optional feature you must turn on, however due dates are not. They are displayed directly on the cards

Sometimes events are time based (like guerilla research for design research) or have dependencies that accept other task, within a sprint. Sometimes tasks are more like epics with time spans that cross sprint boundaries, and sometime tasks relate to real world events or deadlines that don't align with our sprints at all.

If we want the whole organization to be working eventually in Phab dates are important, especially to team like HR or finance that don't even have sprints (to my knowledge)

Qgil moved this task from To Triage to Need discussion on the Phabricator board.Dec 23 2014, 9:16 PM

R&D also receives requests with a fixed delivery date and we would need to have this functionality in Phab to facilitate the migration.

DarTar added a comment.Mar 9 2015, 9:40 PM

Any update on this?

Qgil added a subscriber: greg.Mar 9 2015, 9:47 PM

Was it @greg who was also missing date fields in tasks?

There are two problems here, and none of them is to have a custom field for dates:

  1. As far as I know, a new custom field can be added to tasks, but then it is displayed in all tasks (but I could be wrong). Even if some teams might need a date field in tasks, I guess we agree that we don't need to add such field to all tasks. One solution for this would be to add it in the context of Sprint projects, just like we are adding story points.
  2. Showing a date in the task description is not the big deal, otherwise you could just type it. I guess there are more expectations around this custom field, like showing tasks in calendars or something? This gets complicated, and not necessarily in the direction of the Sprint app.
jayvdb added a subscriber: jayvdb.Jun 11 2015, 2:31 AM

Has anyone explored creating a Phab extension for an advanced custom field, which appears to be able to control when/for-whom it appears?
https://secure.phabricator.com/book/phabricator/article/custom_fields/#advanced-custom-fields
https://secure.phabricator.com/book/phabdev/class/ManiphestCustomField/#method/shouldEnableForRole

mmodell added a subscriber: mmodell.Jul 8 2015, 7:11 AM

@jayvdb: yes we have created advanced custom fields, I have a lot of experience with them. It's not as simple as just displaying a field, dates are complex.

Upstream will eventually add a date field, I believe, at least it seems to be on the roadmap for the calendar app to support embedding dates in other phab apps.

Restricted Application added a subscriber: scfc. · View Herald TranscriptJul 8 2015, 7:11 AM
Aklapper renamed this task from Assign due date to task and have tasks with due dates displayed on a calendar (similar to Trello) to Assign due date to task and have tasks with due dates displayed on a calendar.Aug 19 2015, 12:59 PM
Aklapper updated the task description. (Show Details)

is there any update / ETA on this? We're getting lots of time-sensitive requests with a FDD and it would be super-helpful to be able to specify/visualize a due date.

@DarTar: I'd love to see this happen but I can't see putting a lot of work into a custom solution when upstream has this one the roadmap - it will eventually become a first-class feature, probably better than any kind of custom/unsupported hack that we would come up with.

For now you can watch https://secure.phabricator.com/T7930 for upstream's progress on this one.

I'd really love to see due data capability as well. Right now, the Education team uses Asana for some of the project management. It's great because you can set a due date, and then Asana will remind you that a task is due soon, or that you missed a deadline. It also gives you the option to leave the due date blank, if that just doesn't apply. We all work with both hard and soft deadlines, and having the option to set due dates for the hard deadlines can be really helpful. Also, it shows that Phabricator is not just a brain dump ("let's put all our great ideas in here with no idea of when we'll ever get to them") but will help us prioritize and be clear about what we can commit to and by when.

Restricted Application added a subscriber: Luke081515. · View Herald TranscriptJan 20 2016, 6:11 PM
Ziad awarded a token.Mar 26 2016, 12:31 PM
Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptMay 23 2016, 6:04 PM
Delphine_wmf added a subscriber: Delphine_wmf.

Note that the due date isn't displayed on any calendar but it's at least usable / searchable.

I think the task that I just merged is slightly different than this – I was thinking of something like Reddit's RemindMe bot, which allows people to say "RemindMe! [timeframe]" and receive a ping at the appropriate time.

A usecase might be if someone from the Comms team has responded to a Phab ticket, but no one responds in a timely fashion. A reminder to check that ticket in [a set time frame] could help resurface the issue.

Working on an experimental form for this: https://phabricator.wikimedia.org/maniphest/task/edit/form/37/

For some reason those tasks don't have a "change status" drop down to close them. Not sure if it's a bug or a feature. See for example: https://phabricator.wikimedia.org/T169748

@Delphine_wmf Sorry, that was my fault. It's fixed now.

Working on an experimental form for this: https://phabricator.wikimedia.org/maniphest/task/edit/form/37/

Thanks! Any vague timeline to make this 'non-experimental' and document on https://www.mediawiki.org/wiki/Phabricator/Project_management or https://www.mediawiki.org/wiki/Phabricator/Help (probably worth a subtask, e.g. "Can I search / order tasks by Due Date?" etc)? Asking as I see testing in T170948... :)

@Aklapper: I don't really have a good idea of timeline, I want to get a bit of feedback and experience with the functionality before making any firm commitments ;)

There are currently some problems with the usability of custom forms / custom fields which cause a lot of administrative busywork when setting up custom subtypes. The more types / fields we add the more time consuming it becomes to update them as each new field type gets added to all forms so then I have to go through and manually hide the field in 20 places. This won't scale very far if we add many more fields, forms or subtypes.

In T76094#3452330, @Aklapper wrote: ... "Can I search / order tasks by Due Date?"

Search by due date is somewhat broken currently. I still need to file an upstream task but it's rather complicated bug to reproduce or even describe the issue so I've been procrastinating on filing it upstream.

I would also like to add some more advanced functionality related to this task

  • When a due date is approaching, automatically raise the priority of the task (I believe it was @fgiunchedi who suggested this to me, I can't take the credit)
  • Integration with phabricator calendar so that the due date automatically creates an even in calendar

@Aklapper: I don't really have a good idea of timeline, I want to get a bit of feedback and experience with the functionality before making any firm commitments ;)

There are currently some problems with the usability of custom forms / custom fields which cause a lot of administrative busywork when setting up custom subtypes.

Thanks. I added some preliminary documentation in https://www.mediawiki.org/w/index.php?title=Phabricator%2FProject_management&type=revision&diff=2531226&oldid=2498504

VMasrour-WMF added a subscriber: VMasrour-WMF.